-- name: [CS] Heihachi Mishima
-- description: Your delusions of grandeur finally end here!\n\n\\#ff7777\\This Pack requires Character Select\nto use as a Library!

--[[
    API Documentation for Character Select can be found below:
    https://github.com/Squishy6094/character-select-coop/wiki/API-Documentation

    Use this if you're curious on how anything here works >v<
]]

local TEXT_MOD_NAME = "Character Template"

-- Stops mod from loading if Character Select isn't on
if not _G.charSelectExists then
    djui_popup_create("\\#ffffdc\\\n"..TEXT_MOD_NAME.."\nRequires the Character Select Mod\nto use as a Library!\n\nPlease turn on the Character Select Mod\nand Restart the Room!", 6)
    return 0
end

local E_MODEL_CUSTOM_MODEL = smlua_model_util_get_id("heihachi_geo") -- Located in "actors"

local TEX_CUSTOM_LIFE_ICON = get_texture_info("OLDHEAD") -- Located in "textures"

-- All Located in "sound"
local VOICETABLE_CHAR = {
    [CHAR_SOUND_ATTACKED] = 'Hei-Gah.ogg',
    [CHAR_SOUND_DOH] = 'Hei-Ow.ogg',
    [CHAR_SOUND_DROWNING] = 'Hei-Gunjackscream.ogg',
    [CHAR_SOUND_DYING] = 'Hei-Scream.ogg',
    [CHAR_SOUND_GROUND_POUND_WAH] = 'Hei-Shini.ogg',
    [CHAR_SOUND_HAHA] = 'Hei-LoudLaugh.ogg',
    [CHAR_SOUND_HAHA_2] = 'Hei-Laugh2.ogg',
    [CHAR_SOUND_HERE_WE_GO] = 'Hei-Ooyea.ogg',
    [CHAR_SOUND_HOOHOO] = 'Hei-Hm.ogg',
    [CHAR_SOUND_MAMA_MIA] = 'Hei-Kawa.ogg',
    [CHAR_SOUND_OKEY_DOKEY] = 'Hei-Kekanua2.ogg',
    [CHAR_SOUND_ON_FIRE] = 'Hei-Scream2.ogg',
    [CHAR_SOUND_OOOF] = 'Hei-Ahazaei.ogg',
    [CHAR_SOUND_OOOF2] = 'Hei-Kekanua.ogg',
    [CHAR_SOUND_PUNCH_HOO] = 'Hei-Soriya.ogg',
    [CHAR_SOUND_PUNCH_WAH] = 'Hei-Doriya.ogg',
    [CHAR_SOUND_PUNCH_YAH] = 'Hei-Ha.ogg',
    [CHAR_SOUND_SO_LONGA_BOWSER] = 'Hei-OwariJa.ogg',
    [CHAR_SOUND_TWIRL_BOUNCE] = 'Hei-LoudLaugh.ogg',
    [CHAR_SOUND_WAAAOOOW] = 'Hei-Scream3.ogg',
    [CHAR_SOUND_WAH2] = 'Hei-Soriya.ogg',
    [CHAR_SOUND_WHOA] = 'Hei-Nani.ogg',
    [CHAR_SOUND_YAHOO] = 'Hei-Ashi.ogg',
    [CHAR_SOUND_YAHOO_WAHA_YIPPEE] = 'Hei-Laugh1.ogg',
    [CHAR_SOUND_YAH_WAH_HOO] = 'Hei-Hom.ogg',
    [CHAR_SOUND_YAWNING] = 'Hei-Laugh2.ogg',
    [CHAR_SOUND_LETS_A_GO] = 'Hei-KekanuaLoud.ogg',
}



local PALETTE_CHAR = {
    [PANTS]  = "ffffff",
    [SHIRT]  = "ffffff",
    [GLOVES] = "ffffff",
    [SHOES]  = "ffffff",
    [HAIR]   = "ffffff",
    [SKIN]   = "ffffff",
    [CAP]    = "ffffff",
}

--[[
-- All Located in "textures"
local healthMeter = {
    label = {
        left = get_texture_info("template-hp-back-left"),
        right = get_texture_info("template-hp-back-right"),
    },
    pie = {
        [1] = get_texture_info("template-hp-pie-1"),
        [2] = get_texture_info("template-hp-pie-2"),
        [3] = get_texture_info("template-hp-pie-3"),
        [4] = get_texture_info("template-hp-pie-4"),
        [5] = get_texture_info("template-hp-pie-5"),
        [6] = get_texture_info("template-hp-pie-6"),
        [7] = get_texture_info("template-hp-pie-7"),
        [8] = get_texture_info("template-hp-pie-8"),
    }
}
]]

--[[
    Note: If there are some functionalities you don't care
    to add such as palettes, you can freely remove the function
    for it, the only function you require is character_add
]]

local CSloaded = false
local function on_character_select_load()
    CT_CHAR = _G.charSelect.character_add("Heihachi Mishima", {"I'll snap you like a twig."}, "Tbowskies", {r = 255, g = 128, b = 0}, E_MODEL_CUSTOM_MODEL, CT_MARIO, TEX_CUSTOM_LIFE_ICON)
    _G.charSelect.character_add_caps(E_MODEL_CUSTOM_MODEL, CAPTABLE_CHAR)
    _G.charSelect.character_add_voice(E_MODEL_CUSTOM_MODEL, VOICETABLE_CHAR)
    _G.charSelect.character_add_celebration_star(E_MODEL_CUSTOM_MODEL, E_MODEL_CUSTOM_STAR, TEX_CUSTOM_STAR_ICON)
    _G.charSelect.character_add_palette_preset(E_MODEL_CUSTOM_MODEL, PALETTE_CHAR)
    --_G.charSelect.character_add_health_meter(CT_CHAR, healthMeter)

    CSloaded = true
end

local function on_character_sound(m, sound)
    if not CSloaded then return end
    if _G.charSelect.character_get_voice(m) == VOICETABLE_CHAR then return _G.charSelect.voice.sound(m, sound) end
end

local function on_character_snore(m)
    if not CSloaded then return end
    if _G.charSelect.character_get_voice(m) == VOICETABLE_CHAR then return _G.charSelect.voice.snore(m) end
end

hook_event(HOOK_ON_MODS_LOADED, on_character_select_load)
hook_event(HOOK_CHARACTER_SOUND, on_character_sound)
hook_event(HOOK_MARIO_UPDATE, on_character_snore)